
/*
 *      Daccord - Stub LED for Sandbox v.2.3.0
 */

this.LED = {
    __args:{},
    __argId:0,
    onLoad:null,
    NO_CB:function(){}
};

/*
* necessrio para Android 2.3 at 3.2 e iOS 5.0, que no possuem a prototype.bind
*/
if (!Function.prototype.bind) {
  Function.prototype.bind = function (oThis) {
    if (typeof this !== "function") {
      // closest thing possible to the ECMAScript 5 internal IsCallable function
      throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");
    }
    var aArgs = Array.prototype.slice.call(arguments, 1), 
        fToBind = this, 
        fNOP = function () {},
        fBound = function () {
          return fToBind.apply(this instanceof fNOP && oThis
                                 ? this
                                 : oThis,
                               aArgs.concat(Array.prototype.slice.call(arguments)));
        };
    fNOP.prototype = this.prototype;
    fBound.prototype = new fNOP();
    return fBound;
  };
}

function __initLED(forceAndroid){
  var msg;
  if( forceAndroid == 1 )
  {  
    var callbacks = {};
    var nextCBid = 0; 
	msg = function()
	{
		var args = Array.prototype.splice.call(arguments,0);
		if( !args.length || !args[ args.length-1 ] || !(args[ args.length-1 ] instanceof Function) ) args.push(LED.NO_CB);
		callbacks[++nextCBid] = args.pop();
		args.push( nextCBid );
		__Android.message( JSON.stringify(args) );
	};	
    LED.__callback = function(id){
            var args = Array.prototype.splice.call(arguments, 1);		
            callbacks[id].apply( null, args );
            delete callbacks[id];
    };
  }
  else if( window.__jfxLED )  {
    msg = function()
    {
      LED.__args = Array.prototype.splice.call(arguments, 0);
      try
      {
        window.__jfxLED.msg();
      }catch(e)
      {
          log(e.message);
      }
    };
  } else {
      msg = function(){
        var args = Array.prototype.splice.call(arguments, 0);
        LED.__argId++;
        LED.__args[LED.__argId] = args;
        window.location.href = 'led://' + args.shift() + "?" + LED.__argId;
      };
      LED.deleteArg = function (id){
          delete LED.__args[id];
      };
  }

  // void function loadAppData( Function callback(data, error) )
  LED.loadAppData = msg.bind(null, 'loadAppData');

  // void function playAudio(  String path, boolean doLoop, Function callback(error) )
  LED.playAudio = msg.bind(null, 'playAudio');

  // void function storeAppData(  String data, Function callback(error) )
  LED.storeAppData = msg.bind(null, 'storeAppData');

  // void function callBrowser(  String url, Function callback )
  LED.callBrowser = msg.bind(null, 'callBrowser');

  // void function playVideo(  String path, Function callback(error) )
  LED.playVideo = msg.bind(null, 'playVideo');
  
  // void function disableAllSounds( Function callback() )
  LED.disableAllSounds = msg.bind(null, 'disableAllSounds');

  // void function enableAllSounds( Function callback() )
  LED.enableAllSounds = msg.bind(null, 'enableAllSounds');
  
  // void function closeWidget( Function callback() )
  LED.closeWidget = msg.bind(null, 'closeWidget');
  
  // void function killAllSounds( Function callback() )
  LED.killAllSounds = msg.bind(null, 'killAllSounds');
  
  // void function reloadWidget( Function callback() )
  LED.reloadWidget = msg.bind(null, 'reloadWidget');

  if( LED.onLoad ) LED.onLoad();
}
